* Program ...: Helpdemo.PRG
* Author ....: Joe Stolz
* Date ......: May 1, 1988
* Version ...: dBASE III PLUS
* Notes .....: Demonstrates the use of SET FUNCTION, READ SAVE,
*              READKEY(), and Savescr.BIN in a data-entry program that
*              implements help screens, (seemingly) from within a
*              data-entry screen.
*
*
SET TALK OFF
SET STATUS OFF
CLEAR

* ---Load the .BIN file.
LOAD Savescr

* ---Reset function key 5 to emulate Ctrl-PgUp.
SET FUNCTION 5 TO CHR(31)

* ---Display the help screen and save it in buffer 1.
DO Help
CALL Savescr WITH "S1"

* ---Initialize memory variables for transaction entry.
trns_code = SPACE(3)
loc_code  = 0
from_acct = SPACE(4)
to_acct   = SPACE(4)
amount    = 0
transdt   = DATE()

* ---Draw the data-entry screen.
CLEAR
@  5, 25 SAY "ATM Transaction Entry"
@ 10, 25 SAY "Transaction Date:    " ;
         GET transdt
@ 11, 25 SAY "Transaction Type:    " ;
         GET trns_code
@ 12, 25 SAY "Account 1:           " ;
         GET from_acct
@ 13, 25 SAY "Account 2:           " ;
         GET to_acct
@ 14, 25 SAY "ATM Location:        " ;
         GET loc_code PICTURE "99"
@ 15, 25 SAY "Transaction Amount:  " ;
         GET amount PICTURE "99999.99"
@ 17, 25 SAY "Press <F5> to view codes."


* ---This DO WHILE loop executes until we get a "no" answer
* ---when we ask, "Do you want to re-edit?"
editmore = "Y"
DO WHILE editmore $ "Yy"
	* ---Normally, GETs are CLEARED when READ finishes. 
	* ---READ SAVE leaves the GETs in the GET table so, if
	* ---the program loops back here because the help key was
	* ---pressed, the @/GET commands don't need to be
	* ---re-executed.
	READ SAVE
	
	* ---Test for help key. READKEY() returns 34 if no
	* ---memory variables were changed and returns 290 
	* ---if anything was entered.
	IF MOD(READKEY(), 256) = 34
	   * ---Save the data-entry screen to buffer 2.
	   CALL Savescr WITH "S2"
	   * ---Restore the help screen.
	   CALL Savescr WITH "R1"
	   * ---Pause until a key is hit.
	   DO WHILE INKEY() = 0
	   ENDDO
	   * ---Restore the data-entry screen.
	   CALL Savescr WITH "R2"
	   * ---Go back to the top of the DO WHILE loop in order
	   * ---to reactivate the "SAVED" GETs.
	   LOOP
	ENDIF
	
	* ---Read finished without help.
	* ---Can't use a GET here, because it would reactivate
	* ---all the GETs in the data-entry screen.
	@ 21, 25 SAY "Do you want to re-edit (Y/N)?"
	editmore = ""
	DO WHILE .NOT. editmore $ "YyNn"
	   editmore = CHR(ABS(INKEY()))
	ENDDO
	
	* ---Clear the prompt.
	@ 21, 25
ENDDO

* ---Edit is finished. Clear the GET table.
CLEAR GETS
* ---Reset function key 5.
SET FUNCTION 5 TO
RETURN
* EOP: Helpdemo.PRG

